package com.example.angel.metrosalud

import android.content.Intent
import android.net.Uri
import android.os.Bundle
import android.util.Log
import android.webkit.WebView
import android.webkit.WebViewClient
import androidx.appcompat.app.AppCompatActivity
import com.fasterxml.jackson.databind.ObjectMapper
import okhttp3.*
import okhttp3.MediaType.Companion.toMediaType
import okhttp3.RequestBody.Companion.toRequestBody
import java.io.BufferedReader
import java.io.IOException
import java.io.InputStreamReader
import java.io.OutputStreamWriter
import java.net.HttpURLConnection
import java.net.URL
import java.net.URLEncoder


class AuthorizeStravaActivity : AppCompatActivity() {
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_authorize_strava)
        val myWebView: WebView = findViewById(R.id.webview)
        var intentUri: Uri = Uri.parse("https://www.strava.com/oauth/mobile/authorize")
            .buildUpon()
            .appendQueryParameter("client_id", "61894")
            .appendQueryParameter("redirect_uri", "http://localhost")
            .appendQueryParameter("response_type", "code")
            .appendQueryParameter("approval_prompt", "force")
            //.appendQueryParameter("scope", "activity:write,read")
            .appendQueryParameter("scope", "activity:read_all")
            .build()
        myWebView.webViewClient = object : WebViewClient() {
            override fun shouldOverrideUrlLoading(view: WebView?, url: String?): Boolean {
                val urlUri: Uri = Uri.parse(url)
                if(urlUri.toString().contains("localhost/?state")){ /**We assume response starts with localhost/?state..... */
                    val code = urlUri.getQueryParameter("code")
                    setResult(RESULT_OK, Intent().putExtra("code", code))
                    finish()
                    return true
                }
                return false
            }
        }
        myWebView.loadUrl(intentUri.toString())
    }
}