package com.example.angel.metrosalud.adapters

import android.util.Log
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.example.angel.metrosalud.R
import com.example.angel.metrosalud.data.Parada


import com.example.angel.metrosalud.databinding.ItemStationBinding

class StationAdapter(
    private val stationList: MutableList<Parada>, private val listener: OnItemClickListener) :
        RecyclerView.Adapter<StationAdapter.StationHolder>() {


    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): StationHolder {
        val layoutInflater = LayoutInflater.from(parent.context)
        return StationHolder(layoutInflater.inflate(R.layout.item_station, parent, false))
    }

    override fun getItemCount(): Int = stationList.size

    override fun onBindViewHolder(holder: StationHolder, position: Int) {
        holder.bind(stationList[position], position)
    }

    inner class StationHolder(val view: View) : RecyclerView.ViewHolder(view) {
        private val binding = ItemStationBinding.bind(view)
        fun bind(station: Parada, position: Int) {
            binding.tvStationName.text = station.name
            binding.tvStationDescription.text = station.description
            binding.buttonRemoveStation.tag = position
            binding.buttonRemoveStation.setOnClickListener {
                val selectedItemIndex: Int = adapterPosition
                if (selectedItemIndex != RecyclerView.NO_POSITION) {
                    listener.onRemoveClick(selectedItemIndex)
                }
            }

            binding.buttonEditStation.setOnClickListener {
                Log.d("PRUEBA", "quiero editar este elemento")
                val selectedItemIndex: Int = adapterPosition
                if (selectedItemIndex != RecyclerView.NO_POSITION) {
                    listener.onEditClick(selectedItemIndex)
                }
            }

        }
    }

    interface OnItemClickListener {
        fun onRemoveClick(position: Int)
        fun onEditClick(position: Int)
    }


}


