package com.example.angel.metrosalud.adapters


import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.example.angel.metrosalud.R
import com.example.angel.metrosalud.data.Alumno
import com.example.angel.metrosalud.databinding.ItemStudentBinding
import com.squareup.picasso.Picasso
import jp.wasabeef.picasso.transformations.CropCircleTransformation

class StudentAdapter(
    private val studentList: MutableList<Alumno>, private val listener: OnItemClickListener) :
        RecyclerView.Adapter<StudentAdapter.StudentHolder>() {


    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): StudentHolder {
        val layoutInflater = LayoutInflater.from(parent.context)
        return StudentHolder(layoutInflater.inflate(R.layout.item_student, parent, false))
    }

    override fun getItemCount(): Int = studentList.size

    override fun onBindViewHolder(holder: StudentHolder, position: Int) {
        holder.bind(studentList[position], position)
    }

    inner class StudentHolder(val view: View) : RecyclerView.ViewHolder(view) {
        private val binding = ItemStudentBinding.bind(view)
        fun bind(alumno: Alumno, position: Int) {
            binding.tvPosition.text = (position+1).toString()
            binding.tvStudentName.text = alumno.nombre
            binding.tvStudentSurname.text = "${alumno.apellido1} ${alumno.apellido2}"
            binding.tvStudentPoints.text = alumno.puntos
            Picasso.get()
                .load(alumno.urlPhoto)
                .transform(CropCircleTransformation())
                .placeholder(R.drawable.placeholder)
                .error(R.drawable.placeholder)
                .into(binding.ivStudentPhoto);
        }


    }

    interface OnItemClickListener {
        // fun onRemoveClick(position: Int)
        // fun onEditClick(position: Int)
    }


}


