package com.example.angel.metrosalud.myStrava

import android.net.Uri
import com.fasterxml.jackson.databind.ObjectMapper
import okhttp3.*
import okhttp3.MediaType.Companion.toMediaType
import okhttp3.RequestBody.Companion.toRequestBody
import java.net.URL
import java.text.DateFormat
import java.text.SimpleDateFormat


class myStrava {
    private val CLIENT_ID: String = "61894"
    private val CLIENT_SECRET: String = "d26c90265bbd01c39e5b34355ac7f0d98affd678"
    // private val client: OkHttpClient = OkHttpClient()


    /** Function that gets athlete activities */
    fun getAthleteActivities(code: String, iniDate: String?, endDate: String?, callback: Callback): Call {
        val client = OkHttpClient()
        val url = URL("https://www.strava.com/api/v3/athlete/activities")
        /** Because of epochtime app use api 26*/
        val formatter: DateFormat = SimpleDateFormat("dd/MM/yyyy")
        val iniDate = formatter.parse(iniDate).time/1000
        var endDate = formatter.parse(endDate).time/1000
        val today = System.currentTimeMillis()/1000
        if (endDate > today){
            endDate = today
        }


        var myUrl = Uri.parse("https://www.strava.com/api/v3/athlete/activities")
            .buildUpon()
            .appendQueryParameter("before", endDate.toString())
            .appendQueryParameter("after", "0")
            //.appendQueryParameter("page", "1")
            //.appendQueryParameter("per_page", "30")
            .appendQueryParameter("access_token", code)
            .build()

        val request = Request.Builder()
            .url(myUrl.toString())
            .build()

        val call: Call = client.newCall(request)
        call.enqueue(callback)

        return call
    }

    /** Function that gets new Access Token*/
    fun getAccessToken(refreshToken: String, code: String, callback: Callback): Call {
        val client = OkHttpClient()
        val url = URL("https://www.strava.com/oauth/token")

        /**Use jackson*/
        val mapperAll = ObjectMapper()
        val jacksonObj = mapperAll.createObjectNode()
        jacksonObj.put("grant_type", "refresh_token")
        jacksonObj.put("refresh_token", refreshToken)
        jacksonObj.put("client_id", CLIENT_ID)
        jacksonObj.put("client_secret", CLIENT_SECRET)
        val jacksonString = jacksonObj.toString()

        val mediaType = "application/json; charset=utf-8".toMediaType()
        val body = jacksonString.toRequestBody(mediaType)

        val request = Request.Builder()
            .url(url)
            .header("Authorization", "Bearer $code")
            .post(body)
            .build()

        val call: Call = client.newCall(request)
        call.enqueue(callback)
        return call
    }

    /** Function that links metrosalud with Strava*/
    fun linkStravaAccount(code: String, callback: Callback): Call {

        val client = OkHttpClient()
        val url = URL("https://www.strava.com/oauth/token")

        /**Use jackson*/
        val mapperAll = ObjectMapper()
        val jacksonObj = mapperAll.createObjectNode()
        jacksonObj.put("client_id", CLIENT_ID)
        jacksonObj.put("client_secret", CLIENT_SECRET)
        jacksonObj.put("code", code)
        jacksonObj.put("grant_type", "authorization_code")
        val jacksonString = jacksonObj.toString()

        val mediaType = "application/json; charset=utf-8".toMediaType()
        val body = jacksonString.toRequestBody(mediaType)

        val request = Request.Builder()
            .url(url)
            .post(body)
            .build()

        val call: Call = client.newCall(request)
        call.enqueue(callback)
        return call
    }
}